# 6.1 뉴튼법 
f <- function (x) exp(x) - 2             # (1) f(x)를 정의 
( result <- uniroot(f, c(0, 1)) )        # (2) 범위를 c(0,1)로 지정 
result$root                              # 변수 result에서 해를 추출한다  



# 6.2 다항식의 해 
polyroot(c(2, 3, 1))                     # (x+1)(x+2)=0의 해 
round( polyroot(c(2, 3, 1)), digits=3 )  # (x+1)(x+2)=0의 해
round( polyroot(c(1, 2, 1)), digits=3 )  # (x+1)(x+1)=0의 해 



# 6.3 함수의 미분 
f <- expression( a*x^4 )
D(f, "x")                                # D(수식, 미분할 변수)
DD <- function(expr, name, order = 1) {
  if(order < 1) stop("'order' must be >= 1")
  if(order == 1) D(expr, name)
  else DD(D(expr, name), name, order - 1)
}
DD(f, "x", 3)                            # D(수식, 미분할 변수, 미분횟수)

f <- deriv(~ x^2, "x", func=T)
f(-2)
g <- deriv(~ x^2*y, c("x","y"), func = TRUE)
g(2,3)
h <- deriv(~ x^2*y*z, c("x","y"), function(x, y, z=4){} )
h(3,2)



# 6.4 수치적분 
f <- function(x) x^2
integrate(f, 0, 1)

integrate(sin, 0, pi)
integrate(dnorm, -Inf, 1.96)             # dnorm:정규분포의 밀도함수 
install.packages("cubature",dep=T)       # 설치 
library(cubature)                        # 패키지 호출 
f <- function(x) cos(x)                  # 1변수 함수일 때 
adaptIntegrate(f, 0, pi/2)
g <- function(x) {                       # 2변수 함수일 때 
  exp(-(x[1]^2+x[2]^2)/2)/(2*pi)
}
adaptIntegrate(g, c(-3, -3), c(3, 3))    # 인수는 벡터를 지정 




# 6.5 행렬의 작성과 기본조작 
matrix(1:6, nrow=2, ncol=3)              # nrow로 행수, ncol로 열수를 지정 
matrix(1:6, nrow=2, ncol=3, byrow=T)     # matrix(1:6, 2, 3, byrow=T)도 가능 
( x <- matrix(1:6, nrow=2, ncol=3) )
x[1, 2]                                  # 1행 2열의 성분을 표시 
x[c(1,2), 2]                             # 1,2행의 2열 성분을 표시 
x[2, c(1,2)]                             # 2행 1,2열의 성분을 표시 
x[-1, c(T,F,T)]                          # 1행 비표시, 2행 1,3성분지정 
x[2, ]                                   # 2행을 추출 
x[ ,2]                                   # 2열을 추출 

x[ ,2, drop=F]                           # 2행을 행렬의 형태로 추출한다 
x[c(1,2), c(1,3)]                        # 1,2행과 1,3열을 추출 
x[,-c(1, 3)]                             # 1,3열을 제외한 행렬을 만든다 
x[matrix(c(1,2,2,3), 2, 2)]              # 행렬로 지정 
x[1:4]                                   # 행렬이 벡터로 변환되고 나서 
( x <- rbind(c(1,2,3), c(4,5,6)) )       # 행벡터를 주고 행렬 생성 
( x <- cbind(c(1,2,3), c(4,5,6))  )      # 열벡터를 주고 행렬 생성 
( x <- rbind(1:3, c(4, 5, 6), 7:9) )     # 3개의 행벡터를 결합 
( y <- cbind(1:3, c(4, 5, 6), 7:9) )     # 3개의 열벡터를 결합 


# 6.6 행렬 계산 
a <- matrix(1:4, 2, 2)                   # 2 * 2 행렬 
b <- matrix(0:3, 2, 2)                   # 2 * 2 행렬 
a + b - a %*% b                          # 합.차.곱 
a * b                                    # 요소별 곱셈 
a %o% b                                  # 외적 
a %x% b                                  # 크로네커 곱

a <- matrix(c(1,2,3,4), 2, 2)            # 2 * 2 행렬 
a * (1:2)                                # (1:2) * a도 같은 결과  
1/a

matrix(0, nrow=2, ncol=3)
diag(0, 3)                               # 정방행렬일 때는 diag(0,크기)

( x <- matrix(c(1,2,3,4) , 2, 2) )
t(x)
( x <- diag(2) )                         # diag(1, ncol=2,  nrow=2), diag(1, 3),
                                         # diag(rep(1, 3)), diag(c(1,1)) 등도 가능  
diag(1:3)
x <- matrix(0, ncol=2, nrow=2)           # 모든 성분이 0인 행렬 
diag(x) <- 1                             # 대각 성분을 1로 한다 
x
diag(x) <- c(1, 2)                       # 대각 성분을 1,2로 한다 
x

( x <- matrix(1:9, 3) )
x[upper.tri(x)] <- 0                     # 하삼각행렬(대각포함)을 만든다 
x                                        # x[row(x) < col(x)] <- 0으로도 가능 
x[upper.tri(x, diag=TRUE)] <- 0          # 대각성분도 0으로 할 때 

x
y <- x+t(x)                              # 삼각행렬+삼각행렬의 전치행렬
diag(y) <- diag(y)/2                     # 대각성분을 원래대로 되돌린다 
y                                        # y에 대칭행렬이 만들어진다 
x <- array(runif(8),c(2,4))
sum(x^2)
sum(diag(t(x)%*%x))

a <- matrix(c(0,1,2,3,4,5,6,7,9), 3,3)       #      3y + 6z =  1
b <- matrix(c(1,0,-2))                       #  x + 4y + 7z =  0
solve(a,b)                                   # 2x + 5y + 9z = -2

r <- rbind(c(1,2,3),                         # x + 2y + 3z = 8
           c(1,1,1),                         #      y +  z = 4
           c(1,1,2))                         #          2z = 2
( y <- backsolve(r, x <- c(8,4,2)) )         #
r %*% y                                      # (8   4  2)
( y2 <- backsolve(r, x, transpose = TRUE))   # (8 -12 -5)
all(t(r) %*% y2 == x)
all(y  == backsolve(t(r), x, upper = FALSE, transpose = TRUE) )
all(y2 == backsolve(t(r), x, upper = FALSE, transpose = FALSE))

A <- array(runif(9),c(3,3))
B <- solve(A)                                # 역행렬을 구하는 방법(1)
a <- matrix(c(0,1,2,3,4,5,6,7,9), 3,3)
b <- matrix(c(1,0,0,0,1,0,0,0,1), 3,3)
solve(a,b)                                   # 역행렬을 구하는 방법(2)

A <- matrix(c(1,2,3,4,5,6,7,8,9),c(3,3))
B <- solve(A)                     # 일반 역행렬을 구하는 명령(오류가 난다)
library(MASS)                     # 패키지 호출 
B <- ginv(A)                      # 무어-펜로즈형 일반역행렬 
B

a <- matrix(c(1,2,3,4))
b <- matrix(c(0,-1,-2,1))
crossprod(a,b)                    # 크로스곱 
crossprod(a)                      # 자신의 크로스곱 

a <- matrix(c(0,1,2,3,4,5,6,7,9), 3,3)
eigen(a)
z <- eigen(a)
z$values
z$vectors[,1]                     # 고유값 13. 98...에 대한 고유 벡터
z$vectors[,2]                     # 고유값 -1. 16 ...에 대한 고유 벡터  

hilbert <- function(n) { i <- 1:n;  1/outer(i-1, i, "+") }
h9 <- hilbert(9)
qr(h9)$rank                       # qr()$rank : 행렬이 랭크 
qrh9 <- qr(h9, tol = 1e-10)       # singular value의 어느 값을 0으로 
qrh9$rank                         # 간주할지는 tolerance로 결정한다 
y <- 1:9 / 10
x <- qr.solve(h9, y, tol = 1e-10) # h9 %*% x = y 를 푼다 
x <- qr.coef(qrh9, y)             # solve(h9) %*% y와 같지만 
                                  # 이쪽이 바람직하다
h9 %*% x                          # = y

( a <- matrix(c(5,1,1,3), 2, 2) )
( b <- chol(a) )
crossprod(b)                      # t(b) %*% b
cma <- chol(ma  <- cbind(1, 1:3, c(1,3,7)))
ma %*% chol2inv(cma)                         

a <- matrix(c(1,0.5,0.5,1),2)
svd(a)
eigen(a)

A <- array(c(2,1,1,1,2,1,1,1,2), dim=c(3,3))
U <- svd(A)$u
V <- svd(A)$v
D <- diag(sqrt(svd(A)$d))
B <- U %*% D %*% t(V)             # 행렬 A의 평방근 
A
B
B%*%B

matpow <- function(x, pow=2) {
  y <- eigen(x)
  y$vectors %*% diag( (y$values)^pow ) %*% t(y$vectors)
}
matpow(diag(1:2))                 #행렬((1, 0) , (0, 2))의 제곱 

matexp <- function(x) {
  y <- eigen(x)
  y$vectors %*% diag( exp(y$values) ) %*% t(y$vectors)
}
matexp(matrix(0, 2, 2))           # 제로행렬의 지수승은 단위행렬 
matexp(diag(2))                   # exp(E) = ((e, 0) , (0, e))

a <- matrix(c(0,1,2,3,4,5,6,7,9), 3, 3)
prod(svd(a)$d)
det(a)



# 6.7 그밖의 행렬 조작 
x <- matrix(1:6, nrow=2, ncol=3)             # 2 * 3 행렬을 만든다 
dim(x)                                       # dim 속성을 조사 
nrow(x)                                      # 행수: dim(x)[1]도 같은 결과를 얻을 수 있다 
ncol(x)                                      # 열수: dim(x)[2]도 같은 결과를 얻을 수 있다 
x <- matrix(1:6, nrow=2, ncol=3)             # 2 * 3 행렬을 만든다 
dim(x) <- c(3, 2)                            # 3 * 2 행렬로 강제 변환­
matrix(as.vector(x), nrow=2, ncol=6)         # 2 * 6 행렬로 강제 변환 
matrix(x, nrow=2, ncol=6)                    # matrix()의 제1인수는 

x <- matrix(1:6, nrow=2, ncol=3)             # 2 * 3 행렬 
rownames(x) <- c("up", "down")               # 행의 이름 
colnames(x) <- c("left", "center", "right")  # 열의 이름 
x
x["up","right"]                              # 이름으로 요소에 액세스할 수 있다 
rownames(x) <- NULL                          #­ 행에 추가된 이름을 모두 제거 
colnames(x) <- NULL                          # 열에 추가된 이름을 모두 제거 
dimnames(x) <- NULL                          #­ 양쪽 라벨을 제거 
x <- 1:3
y <- 4:6
matname <- c("x", "y")                       # x, y의 오브젝트명의 문자열 벡터 
sapply(matname, get)                         # x, y를 행렬로(오브젝트명=열라벨)

x <- matrix(1:6, nrow=3)                     # 자동적으로 ncol=2로 된다 
y <- matrix(1:6, ncol=2)                     # 자동적으로 nrow=3으로 된다  
matrix(1, nrow=2, ncol=3)
matrix(1:2, nrow=2, ncol=3)
matrix(1:3, nrow=2, ncol=3, byrow=T)
x <- matrix(1:6, nrow=2, ncol=3)             # 2 * 3 행렬을 만든다 
row(x)                                       # 각 행의 값이 행번호와 같은 행렬 
col(x)                                       # 각 열의 값이 열번호와 같은 행렬 
( x <- matrix(1:12, nrow=3, ncol=4) )        # 3 * 4 행렬을 만든다 
x[1:2, 3:4] <- c(333, 555, 777, 999)         # 대입할 벡터는 
x                                            # 2 * 2의 행렬로 변환된다 
( x <- matrix(1:6, nrow=2, ncol=3) )
( y <- which(x%%2==0, arr.ind=TRUE) )
x[x%%2==0]                                   # 2의 배수인 x의 모든 요소 
x[x%%2==0] <- "*"                            # 행렬 x의 우수요소를 모두 *로 치환 
x                                            # 문자로 마킹하므로 
                                             # 모든 요소가 문자형이 되는 것에 주의 

( x <- matrix(1:4, 2, 2) )
apply(x, 2, sum)                             # 열합 -> 함수 colSums(x)와 같다 
apply(x, 1, sum)                             # 행합 -> 함수 rowSums(x)와 같다 
apply(x, 1, max)                             # 각행의 최댓값을 구한다 
apply(x, 2, min)                             # 각열의 최솟값을 구한다 

( x <- matrix(runif(4), 2, 2) )
order(x[,2])                                 # 2열에 대해 순서를 출력 
x[order(x[,2]),]                             # 2열의 수치가 오름차순이 되게 정렬한다 
x[,order(x[1,])]                             # 1행의 수치가 오름차순이 되게 정렬한다 

x <- matrix(rep(0:1,81), 9, 9)
image(x, col=c(5,9))
