# 10.1. 도움말을 본다 
help(log) 
?log
args(log)    # 함수의 인수를 알고 싶을 때 
help("for") 
help.search("solve")
example(solve) 
par(ask = TRUE) 



# 10.2. 패키지 
library()
library(rgl)
options(repos="http://cran.md.tsukuba.ac.jp")
install.packages("rgl")
install.packages("C:/rgl_0.82.zip", repos=NULL)
update.packages(ask=F, destdir=".")



# 10.3. R에 의한 계산과 수치함수 
x <- pi/2                     # 권장 
pi/2 -> x
x = pi/2
assign("x", pi/2)
sqrt( c(1,2,3,4,5) )          # 1 ... 5 각각에 대해 평방근을 구한다 
factorial(3)



# 10.4. 사용한 변수(오브젝트) 확인과 삭제 
objects()
objects(all=TRUE)             # 도트로 시작되는 파일(숨겨진 오브젝트)를 표시 
rm(x)                         # 오브젝트 x를 삭제할 때 
rm(list=ls(all=TRUE))         # 모든 오브젝트를 삭제할 때 


# 10.5. 함수와 연산자 
sd
mean
methods(mean)
mean.default

x <- 1;   y <- 1.;   z <- 1.00000000001;
if (x == y)                        # 일반적인 동일  판단 
identical(all.equal(x, z), TRUE)   # R이 권장하는 동일 판단 
identical(1, 1.)                   # 1과 1.은 모두 배정도실수 
identical(1, as.integer(1))        # as.integer(1)은 정수형이므로 FALSE가 된다 
x <- 1;   y <- 1.;   u <- 2;
all.equal(x, y)
all.equal(x, u)

x <- 1;  y <- 2;
(x > 0) && (y > 0)
z <- c(3, 4, 5)
( z > c(4, 4, 4) ) | ( z < c(3, 3, 3) )
log(x)    # base 생략 시엔 base=2.71828182845905로 해서 계산 
log(x, 2.718281828)
log(base=2.718281828, x)
log(x <- 2)
x <- 2
log(x)



# 10.6. 반올림과 수치연산오차 
0.6-0.3-0.3
0.6-0.4-0.2
round( 0.6-0.4-0.2 )



# 10.7. 계산방법과 계산속도 
n <- 1000000
x <- runif(n)
y <- runif(n)
system.time( x * y )[3]
system.time( for (i in 1:n) x[i] * y[i] )[3]
n <- 1000000
m <- sqrt(n)
x <- matrix(runif(n), m)
y <- matrix(runif(n), m)
task1 <- function() { x * y }
task2 <- function() for (i in 1:m) for (j in 1:m) x[i,j] * y[i,j]
system.time(task1())[3]
system.time(task2())[3]
system.time( mymontecarlo2(100000, 1, rnorm) )[3]
system.time( mean(rnorm(100000)) )[3]
n <- 10000000
mycointoss1 <- function(n) {
  count <- 0
  for (i in 1:n) if (coin() == 1) count <- count + 1
  return(count)
}
mycointoss2 <- function(n) {
  count <- 0
  for (i in 1:n) count <- count + coin()
  return(count)
}
system.time(mycointoss1(n))[3]
system.time(mycointoss2(n))[3]
mycointoss3 <- function(n) {
  count <- runif(n)
  return( length(count[count <= 0.5]) )
}
system.time(mycointoss3(n))[3]
