# 13.1. 데이터프레임 
id     <- c(1, 2, 3, 4, 5)
sex    <- c("F","F","M","M","M")
height <- c(160,165,170,175,180)
weight <- c( 50, 65, 60, 55, 70)
MYDATA <- data.frame(ID=id, SEX=sex, HEIGHT=height, WEIGHT=weight)
MYDATA

X <- matrix(
  c(1, 1, 160, 50,
    2, 1, 165, 65,
    3, 2, 170, 60,
    4, 2, 175, 55,
    5, 2, 180, 70), 5, by=T)
MYDATA <- data.frame(X)
names(MYDATA) <- c("ID", "SEX", "HEIGHT", "WEIGHT")

MYDATA <- read.table("C:/data/mydata.txt", header=TRUE, sep="")
MYDATA

setwd("C:/data/")
MYDATA <- read.table("mydata.txt", header=TRUE, sep="")

MYDATA <- read.csv("C:/data/mydata.csv", head=T)
MYDATA

MYDATA <- read.delim("mydata2.txt", header=TRUE)

install.packages("RODBC")
library(RODBC)                                     # 패키지 호출 
tmp <- odbcConnectExcel("C:/data/mydata.xls")      # 데이터에 연결  
sqlTables(tmp)                                     # 테이블 표시 
MYDATA <- sqlQuery(tmp,"select * from [Sheet1$]")  # 읽어오기  
odbcClose(tmp)                                     # 연결 끊기 
MYDATA

tmp <- odbcConnectExcel("C:/data/mydata.xls")
MYDATA   <- sqlQuery(tmp, "select * from [Sheet1$A1:B4]")

library(RODBC)                                     # 패키지 호출 
tmp <- odbcConnectAccess("C:/data/mydata.mdb")     # 데이터에 연결 
sqlTables(tmp)                                     # 테이블 표시 
MYDATA <- sqlQuery(tmp, "select * from [mytable]") # 읽어오기 
odbcClose(tmp)                                     # 연결 끊기 
MYDATA

library(foreign)
read.spss("datafile", use.value.labels=FALSE)

read.table(file.choose()) 

MYDATA <- read.csv("C:/data/mydata.csv", head=T)
MYDATA
is.factor(MYDATA$SEX)       # 변수 SEX는 인자형 
is.character(MYDATA$SEX)    # 변수 SEX는 문자형이 아니다 
MYDATA$SEX <- as.character(MYDATA$SEX) # 문자형으로 변환 
is.character(MYDATA$SEX)

MYDATA <- scan("mydata.txt", what="", skip=1, nlines=6)
MYDATA
MYDATA <- data.frame( 
            matrix( scan("mydata.txt", what="",skip=1, nlines=6), 5, by=T )
          )
MYDATA
expand.grid(ID=c("A","B","C"), SEX=c("M","F"))

# 열명을 복사한 경우 
MYDATA <- read.delim("clipboard", header= T )
# 열명을 복사하지 않은 경우 
MYDATA <- read.delim("clipboard", header= F )

# 열명을 복사한 경우 
MYDATA <- read.delim(pipe("pbpaste"), header= T )
# 열명을 복사하지 않은 경우 
MYDATA <- read.delim(pipe("pbpaste"), header= F )

id     <- c(1, 2, 3, 4, 5)
sex    <- c("F","F","M","M","M")
height <- c(160,165,170,175,180)
weight <- c( 50, 65, 60, 55, 70)
MYDATA <- data.frame(ID=id, SEX=sex, HEIGHT=height, WEIGHT=weight)
head(MYDATA, 3)        # 데이터프레임 MYDATA의 처음부터 3행까지 본다 
tail(MYDATA, 3)        # 데이터프레임 MYDATA의 끝에서부터 3행까지 본다 
edit(MYDATA)           # 데이터 에디터로 데이터프레임 MYDATA를 열람 
install.packages("relimp")
library(relimp)
showData(MYDATA)           # 텍스트 윈도우에서 데이터프레임 MYDATA를 열람 
showData(MYDATA[2:4,])     # 2행부터 4행까지 표시 
showData(MYDATA[,1:2])     # 1열부터 2열까지 표시 
summary(MYDATA)
plot(MYDATA)
apply(MYDATA[,c(1,3)], 2, mean)
by(MYDATA[,c(1,3)], MYDATA$SEX, mean)                 #남녀별 평균 
aggregate(MYDATA[,c(1,3)], list(MYDATA[,2]), mean) 
aggregate(MYDATA[,3], list(ID.45=MYDATA$ID>3), mean)  # ID가 3보다 큰가 

# 13.2.데이터 편집 가공방법 
id        <- c(1, 2, 3, 4, 5)
sex       <- c("F","F","M","M","M")
height    <- c(160,165,170,175,180)
weight    <- c( 50, 65, 60, 55, 70)
( MYDATA  <- data.frame(ID=id, SEX=sex, HEIGHT=height) )
( MYDATA2 <- data.frame(ID=id[1:4], WEIGHT=weight[1:4]) )

head(MYDATA, n=2)                       # 데이터프레임 MYDATA의 앞의 2행을 표시 
subset(MYDATA, HEIGHT>165)              # 변수 HEIGHT가 165cm보다 큰 행을 표시 
MYDATA[,c(-1,-2)]
MYDATA$SEX <- NULL
MYDATA

id       <- c(1, 2, 3, 4, 5)
sex      <- c("F","F","M","M","M")
height   <- c(160,165,170,175,180)
( MYDATA <- data.frame(ID=id, SEX=sex, HEIGHT=height) )
x <- order(MYDATA$HEIGHT)               # HEIGHT를 오름차순으로 나열했을 때 행번호 리스트
( MYDATA <- MYDATA[x,] )                # 데이터 정렬 
rownames(MYDATA) <- 1:nrow(MYDATA)      # x의 행라벨에 1:nrow(x)를 지정 
MYDATA

id       <- c(1, 2, 3, 4, 5)
sex      <- c("F","F","M","M","M")
height   <- c(160,165,170,175,180)
( MYDATA <- data.frame(ID=id, SEX=sex, HEIGHT=height) )
x <- order(MYDATA$SEX, MYDATA$HEIGHT)   # 순서를 가져온다 
MYDATA <- MYDATA[x,]                    # 데이터 정렬 
rownames(MYDATA) <- c(1:nrow(MYDATA))   # 행라벨 정리 
MYDATA
weight        <- c(50, 65, 60, 55, 70)
MYDATA$WEIGHT <- weight
MYDATA
cbind(MYDATA[,c(1,2)], MYDATA[,c(1,3)])
data.frame(MYDATA[,c(1,2)], MYDATA[,c(1,3)])
merge(MYDATA[,c(1,2)], MYDATA[,c(1,3)])
merge(MYDATA[,c(1,2)], MYDATA[,c(1,3)], by.x="ID", by.y="ID")
merge(MYDATA, MYDATA2)
merge(MYDATA, MYDATA2, all=TRUE)                            # 모든 행을 남김
merge(MYDATA, MYDATA2, all.y=TRUE)                          # 2인수의 행은 모두 남김MYDATA$HEIGHT <- ifelse(MYDATA$SEX=="F", NA, MYDATA$HEIGHT) # 여성의 체중 숨김(NA로)
MYDATA
df <- data.frame(id=rep(1:4,rep(2,4)),
                 visit=I(rep(c("Before","After"),4)),
                 x=rnorm(4), y=runif(4))
df
reshape(df, timevar="visit", idvar="id", direction="wide", v.names=c("x","y"))
MYDATA <- edit(MYDATA)

data()                         # 모든 데이터 셋을 표시 
data(package ="survival")      # survival 패키지의 데이터 셋으 표시 
data(USArrests, "VADeaths")    # 데이터 USArrests, VADeaths를 로드 
help(USArrests)                # 데이터 USArrests의 도움말을 본다 
library(survival)              # 라이브러리 survival 호출 
data(cancer)                   # 데이터 cancer 호출  

attach(MYDATA)
SEX
data(sleep)                    # R에 표준으로 준비된 데이터(sleep)
sleep                          # W.S.Gosset (Student)의 수면제 비교 데이터 
attach(sleep)                  # attach()를 실행함으로써 
extra                          # extra만으로 데이터에 액세스할 수 있다 
search()                       # 어떤 리스트와 데이터프레임이 있는지 조사한다 
detach(MYDATA)                 # MYDATA를 제거한다 
data(sleep)
with(sleep, {                  # sleep에서 전용 환경을 만들고 
       x <- extra[group==1]    # 그 안에서 작업 :
       y <- extra[group==2]    # 그룹1의 데이터를 x에 
       var.test(x, y)          # 그룹2의 데이터를 y에 대입하고 
     })                        # 분산의 동일성 검증을 한다 



# 13.3. 파일로 데이터 출력 
id       <- c(1, 2, 3, 4, 5)
sex      <- c("F","F","M","M","M")
height   <- c(160,165,170,175,180)
( MYDATA <- data.frame(ID=id, SEX=sex, HEIGHT=height) )
write.table(MYDATA, "C:/data/output.txt",
            quote=FALSE, append=FALSE)
x <- as.matrix(MYDATA)   # MYDATA를 행렬로 변환 
write(t(x), "C:/data/output.txt", ncolumns=ncol(x))
save(MYDATA, file="C:/data/temp.data") # 파일 temp.data는 
rm(MYDATA)                             # 텍스트 데이터가 아니다 
MYDATA
load("temp.data")                      # 데이터 호출 
MYDATA                                 # 내용을 확인 

x <- c(1:9)
out <- NULL
for (i in 1:(length(x)-1)) {
  out <- paste(out, x[i], sep="") 
  out <- paste(out, ",", sep="")
}
out <- paste(out, x[length(x)], sep="")
write(out, file="C:/data/output.txt", ncolumns = 2*length(x))
out <- file("C:/data/output.txt", "w") # 파일을 쓰기 모드로 연다 ­
for (i in 1:10) {
  if (i < 5)       writeLines(paste(i), out, sep=",")
  else if (i == 5) writeLines(paste(i), out, sep="\n")
  else if (i < 10) writeLines(paste(i), out, sep=",")
  else             writeLines(paste(i), out, sep="\n")
}
close(out)                             # 파일을 닫는다 

id       <- c(1, 2, 3, 4, 5)
sex      <- c("F","F","M","M","M")
height   <- c(160,165,170,175,180)
( MYDATA <- data.frame(ID=id, SEX=sex, HEIGHT=height) )
library(xtable)
x <- xtable(MYDATA)    # MYDATA를  xtable형식으로 변환 
print(x)               # LaTeX 형식으로 출력 
print(x,type="html")   # html  형식으로 출력(결과는 생략)
